﻿using DataAccess;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Xml.Serialization;

namespace WebServiceDemo.Model
{
    public class WoundModel
    {
        [XmlRoot(ElementName = "Response")]
        public class WoundResponseItemList<T>
        {
            public string ResultCode { get; set; }
            public string ErrorMsg { get; set; }
            [XmlArray("ItemList"), XmlArrayItem("Item")]
            public List<T> Datas { get; set; }
        }

        public class WoundPatient
        {
            public WoundPatient() { }

            public WoundPatient(Patient patient)
            {
                this.visitDate = patient.VisitDate;
                this.VisitNo = patient.VisitNo;
                this.ClinicLabel = patient.ClinicLabel;
                this.PVID = patient.PVID;
                this.PatientId = patient.PatientId;
                this.Doctor = patient.Doctor;
                this.Sex = patient.Sex;
                this.IndentityNo = patient.IndentityNo;
                this.triageDate = patient.TriageDate;
                this.TriageBy = patient.TriageBy;
                this.TriageTarget = patient.TriageTarget;
                this.TriageLevel = patient.TriageLevel;
                this.VisitID = patient.VisitID;
                this.PatientName = patient.PatientName;
                this.patientBirthDate = patient.PatientBirthDate;
                this.ChargeType = patient.ChargeType;
                this.Identity = patient.Identity;
                this.ContectPhone = patient.ContectPhone;
                this.ContectPerson = patient.ContectPerson;
                this.PatientAddress = patient.PatientAddress;
                this.GreenRoad = patient.GreenRoad;
                this.Diagnosis = patient.Diagnosis;
                this.Status = patient.Status;
                this.RegisterFrom = patient.RegisterFrom;
                this.Nation = patient.Nation;
                this.inDeptTime = patient.InDeptTime;
                this.BedNo = patient.BedNo;
                this.BloodType = patient.BloodType;
                this.RhType = patient.RhType;
            }
            
            public Patient ToPatient()
            {
                Patient patient = new Patient();
                patient.VisitDate = this.visitDate;
                patient.VisitNo = this.VisitNo;
                patient.ClinicLabel = this.ClinicLabel;
                patient.PVID = this.PVID;
                patient.PatientId = this.PatientId;
                patient.Doctor = this.Doctor;
                patient.Sex = this.Sex;
                patient.IndentityNo = this.IndentityNo;
                patient.TriageDate = this.triageDate;
                patient.TriageBy = this.TriageBy;
                patient.TriageTarget = this.TriageTarget;
                patient.TriageLevel = this.TriageLevel;
                patient.VisitID = this.VisitID;
                patient.PatientName = this.PatientName;
                patient.PatientBirthDate = this.patientBirthDate;
                patient.ChargeType = this.ChargeType;
                patient.Identity = this.Identity;
                patient.ContectPhone = this.ContectPhone;
                patient.ContectPerson = this.ContectPerson;
                patient.PatientAddress = this.PatientAddress;
                patient.GreenRoad = this.GreenRoad;
                patient.Diagnosis = this.Diagnosis;
                patient.Status = this.Status;
                patient.RegisterFrom = this.RegisterFrom;
                patient.Nation = this.Nation;
                patient.InDeptTime = this.inDeptTime;
                patient.BedNo = this.BedNo;
                patient.BloodType = this.BloodType;
                patient.RhType = this.RhType;
                return patient;
            }

            [XmlIgnore]
            public DateTime? visitDate { get; set; }
            [XmlElement("VisitDate")]
            public string VisitDate
            {
                get { return visitDate.HasValue ? visitDate.Value.ToString("yyyy-MM-dd") : ""; }
                set { visitDate = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string VisitNo { get; set; }
            public string ClinicLabel { get; set; }
            public string PVID { get; set; }
            public string PatientId { get; set; }
            public string Doctor { get; set; }
            public string Sex { get; set; }
            public string IndentityNo { get; set; }
            [XmlIgnore]
            public DateTime? triageDate { get; set; }
            [XmlElement("TriageDate")]
            public string TriageDate
            {
                get { return triageDate.HasValue ? triageDate.Value.ToString("yyyy-MM-dd HH:mm:ss") : ""; }
                set { triageDate = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string TriageBy { get; set; }
            public string TriageTarget { get; set; }
            public string TriageLevel { get; set; }
            public string VisitID { get; set; }
            public string PatientName { get; set; }
            [XmlIgnore]
            public DateTime? patientBirthDate { get; set; }
            [XmlElement("PatientBirthDate")]
            public string PatientBirthDate
            {
                get { return patientBirthDate.HasValue ? patientBirthDate.Value.ToString("yyyy-MM-dd") : ""; }
                set { patientBirthDate = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string ChargeType { get; set; }
            public string Identity { get; set; }
            public string ContectPhone { get; set; }
            public string ContectPerson { get; set; }
            public string PatientAddress { get; set; }
            public string GreenRoad { get; set; }
            public string Diagnosis { get; set; }
            public string Status { get; set; }
            public string RegisterFrom { get; set; }
            public string Nation { get; set; }
            [XmlIgnore]
            public DateTime? inDeptTime { get; set; }
            [XmlElement("InDeptTime")]
            public string InDeptTime
            {
                get { return inDeptTime.HasValue ? inDeptTime.Value.ToString("yyyy-MM-dd HH:mm:ss") : ""; }
                set { inDeptTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string BedNo { get; set; }
            public string BloodType { get; set; }
            public string RhType { get; set; }
        }

        [XmlRoot(ElementName = "Response")]
        public class WoundResponseVital<T>
        {
            public string ResultCode { get; set; }
            public string ErrorMsg { get; set; }
            [XmlArray("ItemList"), XmlArrayItem("vitalSigns")]
            public List<T> Datas { get; set; }
        }
        
        public class VitalSign
        {
            public VitalSign() { }

            public VitalSign(PatientVitalSign sign) {
                this.ID = sign.Id;
                this.dataDT = sign.DataDT;
                this.ItemName = sign.ItemName;
                this.ItemValue = sign.ItemValue;
                this.ItemArtificial = sign.ItemArtificial;
            }

            public PatientVitalSign TpPatientVitalSign()
            {
                PatientVitalSign sign = new PatientVitalSign();
                sign.Id = this.ID;
                sign.DataDT = this.dataDT;
                sign.ItemName = this.ItemName;
                sign.ItemValue = this.ItemValue;
                sign.ItemArtificial = this.ItemArtificial;
                return sign;
            }

            public long ID { get; set; }
            [XmlIgnore]
            public DateTime? dataDT { get; set; }
            [XmlElement("DataDT")]
            public string DataDT
            {
                get { return dataDT.HasValue ? dataDT.Value.ToString("yyyy/MM/dd HH:mm:ss") : ""; }
                set { dataDT = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string ItemName { get; set; }
            public string ItemValue { get; set; }
            public string ItemArtificial { get; set; }
        }

        [XmlRoot(ElementName = "Response")]
        public class EMGResponseItemlist<T>
        {
            public string ResultCode { get; set; }
            public string ErrorMsg { get; set; }
            [XmlArray("Itemlist"), XmlArrayItem("Item")]
            public List<T> Datas { get; set; }
        }

        [XmlRoot(ElementName = "Response")]
        public class EMGResponseItemlistMaster<T>
        {
            public string ResultCode { get; set; }
            public string ErrorMsg { get; set; }
            [XmlArray("Itemlist"), XmlArrayItem("Master")]
            public List<T> Datas { get; set; }
        }

        public class Order
        {
            public Order() { }
            public Order(DataAccess.Order order) {
                this.OrderId = order.OrderId;
                this.OrderNo = order.OrderNo;
                this.OrderSubNo = order.OrderSubNo;
                this.RepeatIndicator = order.RepeatIndicator;
                this.OrderClass = order.OrderClass;
                this.OrderText = order.OrderText;
                this.Dosage = order.Dosage;
                this.DosageUnits = order.DosageUnits;
                this.DrugSpec = order.DrugSpec;
                this.FirmId = order.FirmId;
                this.Administration = order.Administration;
                this.Frequency = order.Frequency;
                this.FreqCounter = order.FreqCounter;
                this.FreqInterval = order.FreqInterval;
                this.FreqIntervalUnit = order.FreqIntervalUnit;
                this.FreqDetail = order.FreqDetail;
                this.PerformSchedule = order.PerformSchedule;
                this.PerformResult = order.PerformResult;
                this.startDateTime = order.StartDateTime;
                this.stopDateTime = order.StopDateTime;
                this.StartDoctor = order.StartDoctor;
                this.StartNurse = order.StartNurse;
                this.OrderStatus = order.OrderStatus;
                this.BillingAttr = order.BillingAttr;
                this.DrugBillingAttr = order.DrugBillingAttr;
                this.ApplyNo = order.ApplyNo;
                this.lastPerformDateTime = order.LastPerformDateTime;
            }

            public DataAccess.Order ToOrder()
            {
                DataAccess.Order order = new DataAccess.Order();
                order.OrderId = this.OrderId;
                order.OrderNo = this.OrderNo;
                order.OrderSubNo = this.OrderSubNo;
                order.RepeatIndicator = this.RepeatIndicator;
                order.OrderClass = this.OrderClass;
                order.OrderText = this.OrderText;
                order.Dosage = this.Dosage;
                order.DosageUnits = this.DosageUnits;
                order.DrugSpec = this.DrugSpec;
                order.FirmId = this.FirmId;
                order.Administration = this.Administration;
                order.Frequency = this.Frequency;
                order.FreqCounter = this.FreqCounter;
                order.FreqInterval = this.FreqInterval;
                order.FreqIntervalUnit = this.FreqIntervalUnit;
                order.FreqDetail = this.FreqDetail;
                order.PerformSchedule = this.PerformSchedule;
                order.PerformResult = this.PerformResult;
                order.StartDateTime = this.startDateTime;
                order.StopDateTime = this.stopDateTime;
                order.StartDoctor = this.StartDoctor;
                order.StartNurse = this.StartNurse;
                order.OrderStatus = this.OrderStatus;
                order.BillingAttr = this.BillingAttr;
                order.DrugBillingAttr = this.DrugBillingAttr;
                order.ApplyNo = this.ApplyNo;
                order.LastPerformDateTime = this.lastPerformDateTime;
                return order;
            }

            [XmlElement("ORDER_ID")]
            public string OrderId { get; set; }
            [XmlElement("ORDER_NO")]
            public string OrderNo { get; set; }
            [XmlElement("ORDER_SUB_NO")]
            public string OrderSubNo { get; set; }
            [XmlElement("REPEAT_INDICATOR")]
            public string RepeatIndicator { get; set; }
            [XmlElement("ORDER_CLASS")]
            public string OrderClass { get; set; }
            [XmlElement("ORDER_TEXT")]
            public string OrderText { get; set; }
            [XmlElement("DOSAGE")]
            public string Dosage { get; set; }
            [XmlElement("DOSAGE_UNITS")]
            public string DosageUnits { get; set; }
            [XmlElement("DRUG_SPEC")]
            public string DrugSpec { get; set; }
            [XmlElement("FIRM_ID")]
            public string FirmId { get; set; }
            [XmlElement("ADMINISTRATION")]
            public string Administration { get; set; }
            [XmlElement("FREQUENCY")]
            public string Frequency { get; set; }
            [XmlElement("FREQ_COUNTER")]
            public string FreqCounter { get; set; }
            [XmlElement("FREQ_INTERVAL")]
            public string FreqInterval { get; set; }
            [XmlElement("FREQ_INTERVAL_UNIT")]
            public string FreqIntervalUnit { get; set; }
            [XmlElement("FREQ_DETAIL")]
            public string FreqDetail { get; set; }
            [XmlElement("PERFORM_SCHEDULE")]
            public string PerformSchedule { get; set; }
            [XmlElement("PERFORM_RESULT")]
            public string PerformResult { get; set; }
            [XmlIgnore]
            public DateTime? startDateTime { get; set; }
            [XmlElement("START_DATE_TIME")]
            public string StartDateTime
            {
                get { return startDateTime.HasValue ? startDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { startDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            [XmlIgnore]
            public DateTime? stopDateTime { get; set; }
            [XmlElement("STOP_DATE_TIME")]
            public string StopDateTime
            {
                get { return stopDateTime.HasValue ? stopDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { stopDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            [XmlElement("START_DOCTOR")]
            public string StartDoctor { get; set; }
            [XmlElement("START_NURSE")]
            public string StartNurse { get; set; }
            [XmlElement("ORDER_STATUS")]
            public string OrderStatus { get; set; }
            [XmlElement("BILLING_ATTR")]
            public string BillingAttr { get; set; }
            [XmlElement("DRUG_BILLING_ATTR")]
            public string DrugBillingAttr { get; set; }
            [XmlElement("APPLY_NO")]
            public string ApplyNo { get; set; }
            [XmlIgnore]
            public DateTime? lastPerformDateTime { get; set; }
            [XmlElement("LAST_PERFORM_DATE_TIME")]
            public string LastPerformDateTime
            {
                get { return lastPerformDateTime.HasValue ? lastPerformDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { lastPerformDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
        }

        public class OrderCheck
        {
            public OrderCheck() { }

            public OrderCheck(DataAccess.OrderCheck orderCheck) {
                this.SheetClass = orderCheck.SheetClass;
                this.OrderId = orderCheck.OrderId;
                this.OrderNo = orderCheck.OrderNo;
                this.OrderSubNo = orderCheck.OrderSubNo;
                this.RepeatIndicator = orderCheck.RepeatIndicator;
                this.OrderClass = orderCheck.OrderClass;
                this.OrderText = orderCheck.OrderText;
                this.DosageUnits = orderCheck.DosageUnits;
                this.administration = orderCheck.Administration;
                this.frequency = orderCheck.Frequency;
                this.PerformSchedule = orderCheck.PerformSchedule;
                this.scheduleDateTime = orderCheck.ScheduleDateTime;
                this.startDateTime = orderCheck.StartDateTime;
                this.stopDateTime = orderCheck.StopDateTime;
                this.OrderStatus = orderCheck.OrderStatus;
                this.NursePerform = orderCheck.NursePerform;
                this.performDateTime = orderCheck.PerformDateTime;
                this.NurseCheck = orderCheck.NurseCheck;
            }

            public DataAccess.OrderCheck ToOrderCheck()
            {
                DataAccess.OrderCheck orderCheck = new DataAccess.OrderCheck();
                orderCheck.SheetClass = this.SheetClass;
                orderCheck.OrderId = this.OrderId;
                orderCheck.OrderNo = this.OrderNo;
                orderCheck.OrderSubNo = this.OrderSubNo;
                orderCheck.RepeatIndicator = this.RepeatIndicator;
                orderCheck.OrderClass = this.OrderClass;
                orderCheck.OrderText = this.OrderText;
                orderCheck.DosageUnits = this.DosageUnits;
                orderCheck.Administration = this.administration;
                orderCheck.Frequency = this.frequency;
                orderCheck.PerformSchedule = this.PerformSchedule;
                orderCheck.ScheduleDateTime = this.scheduleDateTime;
                orderCheck.StartDateTime = this.startDateTime;
                orderCheck.StopDateTime = this.stopDateTime;
                orderCheck.OrderStatus = this.OrderStatus;
                orderCheck.NursePerform = this.NursePerform;
                orderCheck.PerformDateTime = this.performDateTime;
                orderCheck.NurseCheck = this.NurseCheck;
                return orderCheck;
            }

            [XmlElement("SHEET_CLASS")]
            public string SheetClass { get; set; }
            [XmlElement("ORDER_ID")]
            public string OrderId { get; set; }
            [XmlElement("ORDER_NO")]
            public string OrderNo { get; set; }
            [XmlElement("ORDER_SUB_NO")]
            public string OrderSubNo { get; set; }
            [XmlElement("REPEAT_INDICATOR")]
            public string RepeatIndicator { get; set; }
            [XmlElement("ORDER_CLASS")]
            public string OrderClass { get; set; }
            [XmlElement("ORDER_TEXT")]
            public string OrderText { get; set; }
            [XmlElement("DOSAGE_UNITS")]
            public string DosageUnits { get; set; }
            [XmlElement("ADMINISTRATION")]
            public string administration { get; set; }
            [XmlElement("FREQUENCY")]
            public string frequency { get; set; }
            [XmlElement("PERFORM_SCHEDULE")]
            public string PerformSchedule { get; set; }
            [XmlIgnore]
            public DateTime? scheduleDateTime { get; set; }
            [XmlElement("SCHEDULE_DATE_TIME")]
            public string ScheduleDateTime
            {
                get { return scheduleDateTime.HasValue ? scheduleDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { scheduleDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            [XmlIgnore]
            public DateTime? startDateTime { get; set; }
            [XmlElement("START_DATE_TIME")]
            public string StartDateTime
            {
                get { return startDateTime.HasValue ? startDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { startDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            [XmlIgnore]
            public DateTime? stopDateTime { get; set; }
            [XmlElement("STOP_DATE_TIME")]
            public string StopDateTime
            {
                get { return stopDateTime.HasValue ? stopDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { stopDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            [XmlElement("ORDER_STATUS")]
            public string OrderStatus { get; set; }
            [XmlElement("NURSE_PERFORM")]
            public string NursePerform { get; set; }
            [XmlIgnore]
            public DateTime? performDateTime { get; set; }
            [XmlElement("PERFORM_DATE_TIME")]
            public string PerformDateTime
            {
                get { return performDateTime.HasValue ? performDateTime.Value.ToString("yyyy-MM-dd HH:mm") : ""; }
                set { performDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            [XmlElement("NURSE_CHECK")]
            public string NurseCheck { get; set; }
        }

        public class LabMaster
        {
            public LabMaster() { }

            public LabMaster(DataAccess.LabMaster labMaster) {
                this.TestNo = labMaster.TestNo;
                this.PatientID = labMaster.PatientID;
                this.NotesForSpcm = labMaster.NotesForSpcm;
                this.Subject = labMaster.Subject;
                this.Specimen = labMaster.Specimen;
                this.requestedDateTime = labMaster.RequestedDateTime;
                this.OrderingProvider = labMaster.OrderingProvider;
                this.OrderingDept = labMaster.OrderingDept;
                this.PerformedBy = labMaster.PerformedBy;
                this.sampleDateTime = labMaster.SampleDateTime;
                this.SPCMCollector = labMaster.SPCMCollector;
                this.ResultStatus = labMaster.ResultStatus;
            }

            public DataAccess.LabMaster ToLabMaster()
            {
                DataAccess.LabMaster labMaster = new DataAccess.LabMaster();
                labMaster.TestNo = this.TestNo;
                labMaster.PatientID = this.PatientID;
                labMaster.NotesForSpcm = this.NotesForSpcm;
                labMaster.Subject = this.Subject;
                labMaster.Specimen = this.Specimen;
                labMaster.RequestedDateTime = this.requestedDateTime;
                labMaster.OrderingProvider = this.OrderingProvider;
                labMaster.OrderingDept = this.OrderingDept;
                labMaster.PerformedBy = this.PerformedBy;
                labMaster.SampleDateTime = this.sampleDateTime;
                labMaster.SPCMCollector = this.SPCMCollector;
                labMaster.ResultStatus = this.ResultStatus;
                return labMaster;
            }

            public string TestNo { get; set; }
            public string PatientID { get; set; }
            public string NotesForSpcm { get; set; }
            public string Subject { get; set; }
            public string Specimen { get; set; }
            [XmlIgnore]
            public DateTime? requestedDateTime { get; set; }
            public string RequestedDateTime
            {
                get { return requestedDateTime.HasValue ? requestedDateTime.Value.ToString("yyyy-MM-dd HH:mm:ss") : ""; }
                set { requestedDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string OrderingProvider { get; set; }
            public string OrderingDept { get; set; }
            public string PerformedBy { get; set; }
            [XmlIgnore]
            public DateTime? sampleDateTime { get; set; }
            public string SampleDateTime
            {
                get { return sampleDateTime.HasValue ? sampleDateTime.Value.ToString("yyyy/MM/dd HH:mm:ss") : ""; }
                set { sampleDateTime = string.IsNullOrEmpty(value) ? null : (DateTime?)DateTime.Parse(value); }
            }
            public string SPCMCollector { get; set; }
            public string ResultStatus { get; set; }
        }

        public class LabResult
        {
            public LabResult() { }

            public LabResult(DataAccess.LabResult labResult) {
                this.ItemNo = labResult.ItemNo;
                this.ReportItemName = labResult.ReportItemName;
                this.Result = labResult.Result;
                this.Units = labResult.Units;
                this.AbnormalFlag = labResult.AbnormalFlag;
                this.PrintContext = labResult.PrintContext;
            }

            public DataAccess.LabResult ToLabResult()
            {
                DataAccess.LabResult labResult = new DataAccess.LabResult();
                labResult.ItemNo = this.ItemNo;
                labResult.ReportItemName = this.ReportItemName;
                labResult.Result = this.Result;
                labResult.Units = this.Units;
                labResult.AbnormalFlag = this.AbnormalFlag;
                labResult.PrintContext = this.PrintContext;
                return labResult;
            }

            public string ItemNo { get; set; }
            public string ReportItemName { get; set; }
            public string Result { get; set; }
            public string Units { get; set; }
            public string AbnormalFlag { get; set; }
            public string PrintContext { get; set; }
        }
    }
}