﻿using DataAccess;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Services;
using System.Xml;
using System.Xml.Serialization;
using Utils;
using WebServiceDemo.Model;

namespace WebServiceDemo
{
    /// <summary>
    /// WebServiceDemo 的摘要说明
    /// </summary>
    [WebService(Namespace = "http://plagh.emergency/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // 若要允许使用 ASP.NET AJAX 从脚本中调用此 Web 服务，请取消注释以下行。 
    // [System.Web.Script.Services.ScriptService]
    public class WebServiceDemo : System.Web.Services.WebService
    {

        //[WebMethod]
        //public string GetInDeptPatientList()
        //{
        //    List<Patient> patients = DataAccess.Repository.PatientRepository.FindAllPatients();
        //    List<WoundModel.WoundPatient> woundPatients = patients.ConvertAll<WoundModel.WoundPatient>(t => new WoundModel.WoundPatient(t));

        //    WoundModel.WoundResponseItemList<WoundModel.WoundPatient> response = new WoundModel.WoundResponseItemList<WoundModel.WoundPatient>();
        //    response.ResultCode = "000";
        //    response.ErrorMsg = "";
        //    response.Datas = woundPatients;
        //    return XmlUtils.Object2XmlString(response);
        //}

        //[WebMethod]
        //public string GetPatientVitalSign(string PVID, string BeginDate, string EndDate)
        //{
        //    DateTime start = DateTime.Parse(BeginDate);
        //    DateTime end = DateTime.Parse(EndDate);

        //    List<PatientVitalSign> signs = DataAccess.Repository.PatientVitalSignRepository.FindPatientVitalSignByPVID(PVID, start, end);
        //    List<WoundModel.VitalSign> woundSigns = signs.ConvertAll<WoundModel.VitalSign>(t => new WoundModel.VitalSign(t));

        //    WoundModel.WoundResponseVital<WoundModel.VitalSign> response = new WoundModel.WoundResponseVital<WoundModel.VitalSign>();
        //    response.ResultCode = "000";
        //    response.ErrorMsg = "";
        //    response.Datas = woundSigns;
        //    return XmlUtils.Object2XmlString(response);
        //}

        [WebMethod]
        public string FindOrder(string patientId, string visitId)
        {

            List<Order> orders = DataAccess.Repository.OrderRepository.FindOrdersByPatientIdAndVisitId(patientId, visitId);
            List<WoundModel.Order> woundOrders = orders.ConvertAll<WoundModel.Order>(t => new WoundModel.Order(t));

            WoundModel.EMGResponseItemlist<WoundModel.Order> response = new WoundModel.EMGResponseItemlist<WoundModel.Order>();
            response.ResultCode = "000";
            response.ErrorMsg = "";
            response.Datas = woundOrders;
            return XmlUtils.Object2XmlString(response);
        }

        [WebMethod]
        public string FindOrderCheckList(string patientId, string visitId)
        {

            List<OrderCheck> orderChecks = DataAccess.Repository.OrderCheckRepository.FindOrderChecksByPatientIdAndVisitId(patientId, visitId);
            List<WoundModel.OrderCheck> woundOrderChecks = orderChecks.ConvertAll<WoundModel.OrderCheck>(t => new WoundModel.OrderCheck(t));

            WoundModel.EMGResponseItemlist<WoundModel.OrderCheck> response = new WoundModel.EMGResponseItemlist<WoundModel.OrderCheck>();
            response.ResultCode = "000";
            response.ErrorMsg = "";
            response.Datas = woundOrderChecks;
            return XmlUtils.Object2XmlString(response);
        }

        [WebMethod]
        public string FindLabMaster(string patientId, string visitId)
        {

            List<LabMaster> labMasters = DataAccess.Repository.LabMasterRepository.FindLabMastersByPatientIdAndVisitId(patientId, visitId);
            List<WoundModel.LabMaster> woundLabMasters = labMasters.ConvertAll<WoundModel.LabMaster>(t => new WoundModel.LabMaster(t));

            WoundModel.EMGResponseItemlistMaster<WoundModel.LabMaster> response = new WoundModel.EMGResponseItemlistMaster<WoundModel.LabMaster>();
            response.ResultCode = "000";
            response.ErrorMsg = "";
            response.Datas = woundLabMasters;
            return XmlUtils.Object2XmlString(response);
        }

        [WebMethod]
        public string FindLabResult(string testNo)
        {

            List<LabResult> labResults = DataAccess.Repository.LabResultRepository.FindLabResultsByTestNo(testNo);
            List<WoundModel.LabResult> woundLabResults = labResults.ConvertAll<WoundModel.LabResult>(t => new WoundModel.LabResult(t));

            WoundModel.EMGResponseItemlist<WoundModel.LabResult> response = new WoundModel.EMGResponseItemlist<WoundModel.LabResult>();
            response.ResultCode = "000";
            response.ErrorMsg = "";
            response.Datas = woundLabResults;
            return XmlUtils.Object2XmlString(response);
        }

        //[WebMethod]
        //public string LoadOrders()
        //{
        //    List<WoundModel.Order> list = XmlUtils.XmlFile2Object<WoundModel.EMGResponseItemlist<WoundModel.Order>>("E:/meehealth/cdssData/shi/patient_findOrder_K0489693_2019090600050061.xml").Datas;
        //    list.ForEach(t =>
        //    {
        //        DataAccess.Order order = t.ToOrder();
        //        order.PatientId = "30251";
        //        order.VisitId = "P30251";
        //        DataAccess.Repository.OrderRepository.AddOrder(order);
        //    });
        //    return "OK";
        //}


        //[WebMethod]
        //public string LoadOrderCheck()
        //{
        //    List<WoundModel.OrderCheck> list = XmlUtils.XmlFile2Object<WoundModel.EMGResponseItemlist<WoundModel.OrderCheck>>("E:/meehealth/cdssData/patient_findOrderCheckList_Y4602299_2019090900050122.xml").Datas;
        //    list.ForEach(t =>
        //    {
        //        DataAccess.OrderCheck orderCheck = t.ToOrderCheck();
        //        orderCheck.PatientId = "30251";
        //        orderCheck.VisitId = "P30251";
        //        DataAccess.Repository.OrderCheckRepository.AddOrderCheckr(orderCheck);
        //    });
        //    return "OK";
        //}
    }
}
