﻿using DataAccess;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Services;
using System.Xml;
using System.Xml.Serialization;
using Utils;
using WebServiceDemo.Model;

namespace WebServiceDemo
{
    /// <summary>
    /// WebServiceDemo 的摘要说明
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // 若要允许使用 ASP.NET AJAX 从脚本中调用此 Web 服务，请取消注释以下行。 
    // [System.Web.Script.Services.ScriptService]
    public class WebServiceWound : System.Web.Services.WebService
    {

        [WebMethod]
        public string GetInDeptPatientList()
        {
            List<Patient> patients = DataAccess.Repository.PatientRepository.FindAllPatients();
            List<WoundModel.WoundPatient> woundPatients = patients.ConvertAll<WoundModel.WoundPatient>(t => new WoundModel.WoundPatient(t));

            WoundModel.WoundResponseItemList<WoundModel.WoundPatient> response = new WoundModel.WoundResponseItemList<WoundModel.WoundPatient>();
            response.ResultCode = "000";
            response.ErrorMsg = "";
            response.Datas = woundPatients;
            return XmlUtils.Object2XmlString(response);
        }

        [WebMethod]
        public string GetPatientVitalSign(string PVID, string BeginDate, string EndDate)
        {
            DateTime start = DateTime.Parse(BeginDate);
            DateTime end = DateTime.Parse(EndDate);

            List<PatientVitalSign> signs = DataAccess.Repository.PatientVitalSignRepository.FindPatientVitalSignByPVID(PVID, start, end);
            List<WoundModel.VitalSign> woundSigns = signs.ConvertAll<WoundModel.VitalSign>(t => new WoundModel.VitalSign(t));

            WoundModel.WoundResponseVital<WoundModel.VitalSign> response = new WoundModel.WoundResponseVital<WoundModel.VitalSign>();
            response.ResultCode = "000";
            response.ErrorMsg = "";
            response.Datas = woundSigns;
            return XmlUtils.Object2XmlString(response);
        }
    }
}
